package jp.hishidama.eval.exp;

/**
 * rbgrI_aNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class BitXorExpression extends Col2Expression {

	public BitXorExpression() {
		setOperator("^");
	}

	protected BitXorExpression(BitXorExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new BitXorExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl ^ vr;
	}

	protected double operateDouble(double vl, double vr) {
		return (long) vl ^ (long) vr;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.bitXor(vl, vr);
	}
}
