package jp.hishidama.eval.exp;

/**
 * J}ZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class CommaExpression extends Col2OpeExpression {

	public CommaExpression() {
		setOperator(",");
	}

	protected CommaExpression(CommaExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new CommaExpression(this, s);
	}

	public long evalLong() {
		expl.evalLong();
		return expr.evalLong();
	}

	public double evalDouble() {
		expl.evalDouble();
		return expr.evalDouble();
	}

	public Object evalObject() {
		expl.evalObject();
		return expr.evalObject();
	}

	protected String toStringLeftSpace() {
		return "";
	}
}
