package jp.hishidama.eval.exp;

/**
 * ufNgZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2006.10.31
 */
public class DecAfterExpression extends Col1AfterExpression {

	public DecAfterExpression() {
		setOperator("--");
	}

	protected DecAfterExpression(DecAfterExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new DecAfterExpression(this, s);
	}

	protected long operateLong(long val) {
		exp.let(val - 1, pos);
		return val;
	}

	protected double operateDouble(double val) {
		exp.let(val - 1, pos);
		return val;
	}

	public Object evalObject() {
		Object val = exp.evalObject();
		exp.let(share.oper.inc(val, -1), pos);
		return val;
	}
}
