package jp.hishidama.eval.exp;

/**
 * NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class EqualExpression extends Col2Expression {

	public EqualExpression() {
		setOperator("==");
	}

	protected EqualExpression(EqualExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new EqualExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return (vl == vr) ? TRUE : FALSE;
	}

	protected double operateDouble(double vl, double vr) {
		return (vl == vr) ? TRUE : FALSE;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.equal(vl, vr);
	}
}
