package jp.hishidama.eval.exp;

import java.util.List;

/**
 * ֐NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2006.11.07
 * @version 2007.02.17
 */
public class FuncArgExpression extends Col2OpeExpression {

	public FuncArgExpression() {
		setOperator(",");
	}

	protected FuncArgExpression(FuncArgExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new FuncArgExpression(this, s);
	}

	protected void evalArgsLong(List args) {
		expl.evalArgsLong(args);
		expr.evalArgsLong(args);
	}

	protected void evalArgsDouble(List args) {
		expl.evalArgsDouble(args);
		expr.evalArgsDouble(args);
	}

	protected void evalArgsObject(List args) {
		expl.evalArgsObject(args);
		expr.evalArgsObject(args);
	}

	protected String toStringLeftSpace() {
		return "";
	}
}
