package jp.hishidama.eval.exp;

/**
 * rZi>jNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class GreaterThanExpression extends Col2Expression {

	public GreaterThanExpression() {
		setOperator(">");
	}

	protected GreaterThanExpression(GreaterThanExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new GreaterThanExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return (vl > vr) ? TRUE : FALSE;
	}

	protected double operateDouble(double vl, double vr) {
		return (vl > vr) ? TRUE : FALSE;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.greaterThan(vl, vr);
	}
}
