package jp.hishidama.eval.exp;

/**
 * ZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class IfExpression extends Col3Expression {

	public IfExpression() {
		setOperator("?");
		setEndOperator(":");
	}

	protected IfExpression(IfExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new IfExpression(this, s);
	}

	public long evalLong() {
		if (exp1.evalLong() != FALSE) {
			return exp2.evalLong();
		} else {
			return exp3.evalLong();
		}
	}

	public double evalDouble() {
		if (exp1.evalDouble() != FALSE) {
			return exp2.evalDouble();
		} else {
			return exp3.evalDouble();
		}
	}

	public Object evalObject() {
		if (share.oper.bool(exp1.evalObject())) {
			return exp2.evalObject();
		} else {
			return exp3.evalObject();
		}
	}

	/*---
	protected AbstractExpression optimize(boolean lng) {
		exp1 = exp1.optimize(lng);
		if (exp1.isConst()) {
			if (exp1.isTrue(lng)) {
				return exp2.optimize(lng);
			} else {
				return exp3.optimize(lng);
			}
		}
		exp2 = exp2.optimize(lng);
		exp3 = exp3.optimize(lng);
		return this;
	}*/
}
