package jp.hishidama.eval.exp;

/**
 * rZi<=jNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class LessEqualExpression extends Col2Expression {

	public LessEqualExpression() {
		setOperator("<=");
	}

	protected LessEqualExpression(LessEqualExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new LessEqualExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return (vl <= vr) ? TRUE : FALSE;
	}

	protected double operateDouble(double vl, double vr) {
		return (vl <= vr) ? TRUE : FALSE;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.lessEqual(vl, vr);
	}
}
