package jp.hishidama.eval.exp;

/**
 * ZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class LetExpression extends Col2OpeExpression {

	public LetExpression() {
		setOperator("=");
	}

	protected LetExpression(LetExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new LetExpression(this, s);
	}

	public long evalLong() {
		long val = expr.evalLong();
		expl.let(val, pos);
		return val;
	}

	public double evalDouble() {
		double val = expr.evalDouble();
		expl.let(val, pos);
		return val;
	}

	public Object evalObject() {
		Object val = expr.evalObject();
		expl.let(val, pos);
		return val;
	}

	protected AbstractExpression replace() {
		expl = expl.replaceVar();
		expr = expr.replace();
		return share.repl.replaceLet(this);
	}
}
