package jp.hishidama.eval.exp;

/**
 * ZZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class LetPlusExpression extends PlusExpression {

	public LetPlusExpression() {
		setOperator("+=");
	}

	protected LetPlusExpression(LetPlusExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new LetPlusExpression(this, s);
	}

	public long evalLong() {
		long val = super.evalLong();
		expl.let(val, pos);
		return val;
	}

	public double evalDouble() {
		double val = super.evalDouble();
		expl.let(val, pos);
		return val;
	}

	public Object evalObject() {
		Object val = super.evalObject();
		expl.let(val, pos);
		return val;
	}

	protected AbstractExpression replace() {
		expl = expl.replaceVar();
		expr = expr.replace();
		return share.repl.replaceLet(this);
	}
}
