package jp.hishidama.eval.exp;

/**
 * ݏZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2007.02.16
 */
public class LetPowerExpression extends PowerExpression {

	public LetPowerExpression() {
		setOperator("**=");
	}

	protected LetPowerExpression(LetPowerExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new LetPowerExpression(this, s);
	}

	public long evalLong() {
		long val = super.evalLong();
		expl.let(val, pos);
		return val;
	}

	public double evalDouble() {
		double val = super.evalDouble();
		expl.let(val, pos);
		return val;
	}

	public Object evalObject() {
		Object val = super.evalObject();
		expl.let(val, pos);
		return val;
	}

	protected AbstractExpression replace() {
		expl = expl.replaceVar();
		expr = expr.replace();
		return share.repl.replaceLet(this);
	}
}
