package jp.hishidama.eval.exp;

/**
 * EVtgZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class LetShiftRightExpression extends ShiftRightExpression {

	public LetShiftRightExpression() {
		setOperator(">>=");
	}

	protected LetShiftRightExpression(LetShiftRightExpression from,
			ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new LetShiftRightExpression(this, s);
	}

	public long evalLong() {
		long val = super.evalLong();
		expl.let(val, pos);
		return val;
	}

	public double evalDouble() {
		double val = super.evalDouble();
		expl.let(val, pos);
		return val;
	}

	public Object evalObject() {
		Object val = super.evalObject();
		expl.let(val, pos);
		return val;
	}

	protected AbstractExpression replace() {
		expl = expl.replaceVar();
		expr = expr.replace();
		return share.repl.replaceLet(this);
	}
}
