package jp.hishidama.eval.exp;

/**
 * sNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class NotEqualExpression extends Col2Expression {

	public NotEqualExpression() {
		setOperator("!=");
	}

	protected NotEqualExpression(NotEqualExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new NotEqualExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return (vl != vr) ? TRUE : FALSE;
	}

	protected double operateDouble(double vl, double vr) {
		return (vl != vr) ? TRUE : FALSE;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.notEqual(vl, vr);
	}
}
