package jp.hishidama.eval.exp;

/**
 * _ےNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class NotExpression extends Col1Expression {

	public NotExpression() {
		setOperator("!");
	}

	protected NotExpression(NotExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new NotExpression(this, s);
	}

	protected long operateLong(long val) {
		return (val == 0) ? TRUE : FALSE;
	}

	protected double operateDouble(double val) {
		return (val == 0) ? TRUE : FALSE;
	}

	public Object evalObject() {
		return share.oper.not(exp.evalObject());
	}
}
