package jp.hishidama.eval.exp;

/**
 * œK(double)NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2007.02.20
 */
public class OptimizeDouble extends OptimizeObject {

	protected boolean isTrue(AbstractExpression x) {
		return x.evalDouble() != 0;
	}

	protected AbstractExpression toConst(AbstractExpression exp) {
		try {
			double val = exp.evalDouble();
			return NumberExpression.create(exp, Double.toString(val));
		} catch (Exception e) {
			return exp;
		}
	}
}
