package jp.hishidama.eval.exp;

/**
 * _aNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class OrExpression extends Col2OpeExpression {

	public OrExpression() {
		setOperator("||");
	}

	protected OrExpression(OrExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new OrExpression(this, s);
	}

	public long evalLong() {
		long val = expl.evalLong();
		if (val != FALSE)
			return val;
		return expr.evalLong();
	}

	public double evalDouble() {
		double val = expl.evalDouble();
		if (val != FALSE)
			return val;
		return expr.evalDouble();
	}

	public Object evalObject() {
		Object val = expl.evalObject();
		if (share.oper.bool(val)) {
			return val;
		}
		return expr.evalObject();
	}
}
