package jp.hishidama.eval.exp;

/**
 * EVtgNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class ShiftRightExpression extends Col2Expression {

	public ShiftRightExpression() {
		setOperator(">>");
	}

	protected ShiftRightExpression(ShiftRightExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new ShiftRightExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl >> vr;
	}

	protected double operateDouble(double vl, double vr) {
		return vl / Math.pow(2, vr);
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.shiftRight(vl, vr);
	}
}
