package jp.hishidama.eval.func;

import java.lang.reflect.Method;


/**
 * tNVgp֐.
 * <p>
 * tNVMethod#invoke()gpăIuWFNg̃\bhĂяoB<br>
 * IuWFNgꍇ0nullԂB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2007.02.16
 */
public class InvokeFunction implements Function {

	public long evalLong(Object object, String name, Long[] args)
			throws Throwable {
		if (object == null) {
			return 0;
		}

		Object r = callMethod(object, name, args);
		return ((Number) r).longValue();
	}

	public double evalDouble(Object object, String name, Double[] args)
			throws Throwable {
		if (object == null) {
			return 0;
		}

		Object r = callMethod(object, name, args);
		return ((Number) r).doubleValue();
	}

	public Object evalObject(Object object, String name, Object[] args)
			throws Throwable {
		if (object == null) {
			return null;
		}

		return callMethod(object, name, args);
	}

	public static Object callMethod(Object obj, String name, Object[] args)
			throws Exception {
		Class c = obj.getClass();
		Class[] types = new Class[args.length];
		for (int i = 0; i < types.length; i++) {
			types[i] = args[i].getClass();
		}
		Method m = c.getMethod(name, types);
		return m.invoke(obj, args);
	}

}
