package jp.hishidama.eval.exp;

/**
 * _σNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class AndExpression extends Col2OpeExpression {

	public AndExpression() {
		setOperator("&&");
	}

	protected AndExpression(AndExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new AndExpression(this, s);
	}

	public long evalLong() {
		long val = expl.evalLong();
		if (val == FALSE)
			return val;
		return expr.evalLong();
	}

	public double evalDouble() {
		double val = expl.evalDouble();
		if (val == FALSE)
			return val;
		return expr.evalDouble();
	}

	public Object evalObject() {
		Object val = expl.evalObject();
		if (!share.oper.bool(val)) {
			return val;
		}
		return expr.evalObject();
	}
}
