package jp.hishidama.eval.exp;

/**
 * rbg_σNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class BitAndExpression extends Col2Expression {

	public BitAndExpression() {
		setOperator("&");
	}

	protected BitAndExpression(BitAndExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new BitAndExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl & vr;
	}

	protected double operateDouble(double vl, double vr) {
		return (long) vl & (long) vr;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.bitAnd(vl, vr);
	}
}
