package jp.hishidama.eval.exp;

/**
 * rbgےNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class BitNotExpression extends Col1Expression {

	public BitNotExpression() {
		setOperator("~");
	}

	protected BitNotExpression(BitNotExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new BitNotExpression(this, s);
	}

	protected long operateLong(long val) {
		return ~val;
	}

	protected double operateDouble(double val) {
		return ~(long) val;
	}

	public Object evalObject() {
		return share.oper.bitNot(exp.evalObject());
	}
}
