package jp.hishidama.eval.exp;

/**
 * rbg_aNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class BitOrExpression extends Col2Expression {

	public BitOrExpression() {
		setOperator("|");
	}

	protected BitOrExpression(BitOrExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new BitOrExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl | vr;
	}

	protected double operateDouble(double vl, double vr) {
		return (long) vl | (long) vr;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.bitOr(vl, vr);
	}
}
