package jp.hishidama.eval.exp;

/**
 * OufNgZqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2006.10.31
 */
public class DecBeforeExpression extends Col1Expression {

	public DecBeforeExpression() {
		setOperator("--");
	}

	protected DecBeforeExpression(DecBeforeExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new DecBeforeExpression(this, s);
	}

	protected long operateLong(long val) {
		--val;
		exp.let(val, pos);
		return val;
	}

	protected double operateDouble(double val) {
		--val;
		exp.let(val, pos);
		return val;
	}

	public Object evalObject() {
		Object val = exp.evalObject();
		val = share.oper.inc(val, -1);
		exp.let(val, pos);
		return val;
	}

	protected AbstractExpression replace() {
		exp = exp.replaceVar();
		return share.repl.replaceVar1(this);
	}
}
