package jp.hishidama.eval.exp;

/**
 * ZNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class DivExpression extends Col2Expression {

	public DivExpression() {
		setOperator("/");
	}

	protected DivExpression(DivExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new DivExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl / vr;
	}

	protected double operateDouble(double vl, double vr) {
		return vl / vr;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.div(vl, vr);
	}
}
