package jp.hishidama.eval.exp;

/**
 * ZNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class MultExpression extends Col2Expression {

	public MultExpression() {
		setOperator("*");
	}

	protected MultExpression(MultExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new MultExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl * vr;
	}

	protected double operateDouble(double vl, double vr) {
		return vl * vr;
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.mult(vl, vr);
	}
}
