package jp.hishidama.eval.exp;

/**
 * ʃNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2007.02.17
 */
public class ParenExpression extends Col1Expression {

	public ParenExpression() {
		setOperator("(");
		setEndOperator(")");
	}

	protected ParenExpression(ParenExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new ParenExpression(this, s);
	}

	protected long operateLong(long val) {
		return val;
	}

	protected double operateDouble(double val) {
		return val;
	}

	public Object evalObject() {
		return exp.evalObject();
	}

	public String toString() {
		if (exp == null) {
			return "";
		}
		return getOperator() + exp.toString() + getEndOperator();
	}
}
