package jp.hishidama.eval.exp;

/**
 * VtgNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class ShiftLeftExpression extends Col2Expression {

	public ShiftLeftExpression() {
		setOperator("<<");
	}

	protected ShiftLeftExpression(ShiftLeftExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new ShiftLeftExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl << vr;
	}

	protected double operateDouble(double vl, double vr) {
		return vl * Math.pow(2, vr);
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.shiftLeft(vl, vr);
	}
}
