package jp.hishidama.eval.exp;

/**
 * EVtg(Ȃ)NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class ShiftRightLogicalExpression extends Col2Expression {

	public ShiftRightLogicalExpression() {
		setOperator(">>>");
	}

	protected ShiftRightLogicalExpression(ShiftRightLogicalExpression from,
			ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new ShiftRightLogicalExpression(this, s);
	}

	protected long operateLong(long vl, long vr) {
		return vl >>> vr;
	}

	protected double operateDouble(double vl, double vr) {
		if (vl < 0)
			vl = -vl;
		return vl / Math.pow(2, vr);
	}

	protected Object operateObject(Object vl, Object vr) {
		return share.oper.shiftRightLogical(vl, vr);
	}
}
