package jp.hishidama.eval.exp;

/**
 * NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class SignMinusExpression extends Col1Expression {

	public SignMinusExpression() {
		setOperator("-");
	}

	protected SignMinusExpression(SignMinusExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new SignMinusExpression(this, s);
	}

	protected long operateLong(long val) {
		return -val;
	}

	protected double operateDouble(double val) {
		return -val;
	}

	public Object evalObject() {
		return share.oper.signMinus(exp.evalObject());
	}
}
