package jp.hishidama.eval.exp;

/**
 * NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class SignPlusExpression extends Col1Expression {

	public SignPlusExpression() {
		setOperator("+");
	}

	protected SignPlusExpression(SignPlusExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new SignPlusExpression(this, s);
	}

	protected long operateLong(long val) {
		return val;
	}

	protected double operateDouble(double val) {
		return val;
	}

	public Object evalObject() {
		return share.oper.signPlus(exp.evalObject());
	}
}
