package jp.hishidama.eval.exp;

/**
 * ʎqNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public abstract class WordExpression extends AbstractExpression {

	/** ʎq. */
	protected String word;

	/**
	 * RXgN^[.
	 * 
	 * @param str
	 *            ʎq
	 */
	protected WordExpression(String str) {
		word = str;
	}

	protected WordExpression(WordExpression from, ShareExpValue s) {
		super(from, s);
		word = from.word;
	}

	protected String getWord() {
		return word;
	}

	protected void setWord(String word) {
		this.word = word;
	}

	protected int getCols() {
		return 0;
	}

	protected int getFirstPos() {
		return pos;
	}

	protected void search() {
		share.srch.search(this);
		if (share.srch.end())
			return;
		share.srch.search0(this);
	}

	protected AbstractExpression replace() {
		return share.repl.replace0(this);
	}

	protected AbstractExpression replaceVar() {
		return share.repl.replaceVar0(this);
	}

	public boolean equals(Object obj) {
		if (obj instanceof WordExpression) {
			WordExpression e = (WordExpression) obj;
			if (getClass() == e.getClass()) {
				return word.equals(e.word);
			}
		}
		return false;
	}

	public int hashCode() {
		return word.hashCode();
	}

	public void dump(int n) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < n; i++) {
			sb.append(' ');
		}
		sb.append(word);
		System.out.println(sb.toString());
	}

	public String toString() {
		return word;
	}
}
