package jp.hishidama.eval.var;

import java.lang.reflect.*;
import java.util.*;

/**
 * ϐǗNX.
 * <p>
 * ϐƕϐlǗB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2007.02.13
 * @version 2007.02.14
 */
public class MapVariable implements Variable {

	protected Map map;

	/**
	 * RXgN^[.
	 * <p>
	 * ̕ϐ}bv쐬B
	 * </p>
	 */
	public MapVariable() {
		this(new HashMap());
	}

	/**
	 * RXgN^[.
	 * 
	 * @param varMap
	 *            ϐ}bv
	 */
	public MapVariable(Map varMap) {
		map = varMap;
	}

	/**
	 * ϐ}bvݒ.
	 * <p>
	 * ϐ(String)ƒl̃}bvݒ肷B
	 * </p>
	 * <p>
	 * ll̏ꍇNumberiLongDoublejł邱ƁB<br>
	 * varMap.put("var", new Long(1));
	 * </p>
	 * <p>
	 * lȊOizj̏ꍇJavãIuWFNĝ܂܊i[B<br>
	 * Long[] arr = new Long[2]; varMap.put("arr", arr);
	 * </p>
	 * 
	 * @param varMap
	 *            ϐ}bv
	 */
	public void setMap(Map varMap) {
		map = varMap;
	}

	/**
	 * ϐ}bv擾.
	 * 
	 * @return ϐ}bv
	 */
	public Map getMap() {
		return map;
	}

	/**
	 * ϐݒ.
	 * <p>
	 * ϐɒlZbgB
	 * </p>
	 * 
	 * @param name
	 * @param obj
	 */
	public void setValue(Object name, Object obj) {
		map.put(name, obj);
	}

	/**
	 * ϐIuWFNg擾.
	 * <p>
	 * ϐ\IuWFNgԂBiPȂϐzzj
	 * </p>
	 * 
	 * @param name
	 *            ϐ
	 * @return ϐIuWFNg
	 */
	public Object getObject(Object name) {
		return map.get(name);
	}

	/**
	 * l擾(long).
	 * 
	 * @param val
	 *            lIuWFNg
	 * @return longl
	 * @since 2007.02.14
	 */
	public long evalLong(Object val) {
		return ((Number) val).longValue();
	}

	/**
	 * l擾(double).
	 * 
	 * @param val
	 *            lIuWFNg
	 * @return doublel
	 * @since 2007.02.14
	 */
	public double evalDouble(Object val) {
		return ((Number) val).doubleValue();
	}

	/**
	 * ϐIuWFNg擾.
	 * <p>
	 * z̗vfԂB
	 * </p>
	 * 
	 * @param array
	 *            z
	 * @param index
	 *            Y
	 * @return vfIuWFNg
	 * @since 2007.02.14
	 */
	public Object getObject(Object array, int index) {
		return Array.get(array, index);
	}

	/**
	 * zlݒ.
	 * <p>
	 * zɒlZbgB
	 * </p>
	 * 
	 * @param array
	 *            z
	 * @param index
	 *            Y
	 * @param val
	 *            l
	 * @since 2007.02.14
	 */
	public void setValue(Object array, int index, Object val) {
		Array.set(array, index, val);
	}

	/**
	 * tB[hIuWFNg擾.
	 * <p>
	 * IuWFNg̃tB[h̃IuWFNgԂB
	 * </p>
	 * 
	 * @param obj
	 *            IuWFNg
	 * @param field
	 *            tB[h
	 * @return vfIuWFNg
	 * @since 2007.02.14
	 */
	public Object getObject(Object obj, String field) {
		try {
			Class c = obj.getClass();
			Field f = c.getField(field);
			return f.get(obj);
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			// System.out.println("MapVariable#getObject() " + obj + "." +
			// field);
			throw new RuntimeException(e);
		}
	}

	/**
	 * tB[hlݒ.
	 * <p>
	 * IuWFNg̃tB[hɒlZbgB
	 * </p>
	 * 
	 * @param obj
	 *            IuWFNg
	 * @param field
	 *            tB[h
	 * @param val
	 *            l
	 * @since 2007.02.14
	 */
	public void setValue(Object obj, String field, Object val) {
		try {
			Class c = obj.getClass();
			Field f = c.getField(field);
			f.set(obj, val);
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}
